/* dpsp_sub.h @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

/* ......................................................................... */

struct	DPS_FMTS			/* --------  Sample  --------------- */
  {	unsigned	int	mode;	/* 0 -                       */
					/* 1 -    (⥬ 0)     */
					/* 2 -   横  0          */
			char	fmt;	/* Format 0, 1 or 2                  */
	unsigned	char	*pbuf;	/*                              */
	unsigned	int	pblen;	/*   ⥪騩             */
	unsigned	int	tblen;	/*   騩 >= pblen      */
	unsigned	int	pbcur;  /* 饥           */
	unsigned	int	cou;	/* 稪 ७  㪠   */
  };

/* .................................................. */

struct	DPS_FMTM			/* ------------  Melody  ----------- */
  {	unsigned	int	mode;	/* 0 -                       */
					/* 1 -    (⥬ 0)     */
					/* 2 -   横  0          */
			int	*mbuf;	/*   (delay)             */
			int	mblen;	/*                       */
			int	mtblen;	/*   騩 >= mblen      */
			int	mbcur;  /* 饥           */
	unsigned	int	mcou;	/* 稪 ७       */
  };

/* .................................................. */
/* ......................................................................... */

#define	TIMER_DIVIDER	0x40
extern	int	current_volume;

/* ......................................................................... */

/* dpsp_sub.c @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

#include	<stddef.h>
#include	<dos.h>
#include	"dpsp_sub.h"

#define	EOS	'\0'

#define	SOUND_ON()	outportb ( 0x61, inportb (0x61) | 0x03 )
#define	SOUND_OFF()	outportb ( 0x61, inportb (0x61) & 0xfc )

/* ......................................................................... */

int	current_volume = 0x20;


static	struct	DPS_FMTS	*dps_fp;
static	struct	DPS_FMTM	*dpsm_fp;

extern	void	interrupt	sub8i_dps_wait ();
extern	void	interrupt	sub8i_dps1     ();
extern	void	interrupt	sub8i_dps2     ();
extern	void	interrupt	sub8i_dps2_mel ();

static	void	interrupt	(*dps8i) () = NULL;
static	void	interrupt	(*dos8i) () = NULL;

static	long	dps_tick_count = 0l;

/* ......................................................................... */

static	unsigned	int	t_cou = 0;	/* Counnt for sample         */
static	unsigned	int	n_cou = 0;	/*            melody         */
static	unsigned	long	w_cou = 0l;	/*            wait           */
static			int	w_mod = 0;	/* Mode for wait  0-disable  */

/* ......................................................................... */
/* ......................................................................... */

_dpsp_ini	()
{	if ( dos8i == NULL )	dos8i = getvect ( 0x08 );	}

/* ......................................................................... */

_dpsp_start	( int mode, struct DPS_FMTS *sp, int wait )
{
if ( dos8i == NULL )	dos8i = getvect ( 0x08 );

if ( mode < 1 || mode > 3 )	mode = 0;

					/* ந ⠩  뢮  */
dps_fp = sp;	dps_fp->mode = 0;
switch ( dps_fp->fmt )
 {  case 0:
    case 1:	dps8i = sub8i_dps1;	break;
    case 2:	dps8i = sub8i_dps2;	break;
    default:	dps8i = sub8i_dps1;	break;
 }
w_mod = 0;
wait  = (wait < 0)?  0:  wait;
w_cou = (1193180l / (long) (TIMER_DIVIDER)) * (long) (wait);
setvect ( 0x08, sub8i_dps_wait );

disable  ();
	outportb ( 0x43, bin ("00.11.010.0") );
	outportb ( 0x40,  TIMER_DIVIDER       & 0xFF );
	outportb ( 0x40, (TIMER_DIVIDER >> 8) & 0xFF );

	SOUND_OFF ();
	outportb ( 0x43, bin ("10.01.000.0") );
	SOUND_ON  ();
enable ();

t_cou         = 0;
dps_fp->pbcur = 0;
dps_fp->mode  = mode;

w_mod = 1;
}


/* ......................................................................... */

_dpsp_melody	( int mode, struct DPS_FMTS *smp,
		  struct DPS_FMTM *mel, int wait  )
{
if ( dos8i == NULL )	dos8i = getvect ( 0x08 );

if ( mel->mcou == 0 )		mel->mcou = 0x0900;
if ( mode < 1 || mode > 3 )	mode = 0;

					/* ந ⠩  뢮  */
dps_fp  = smp;	dps_fp->mode  = 0;
dpsm_fp = mel;	dpsm_fp->mode = 0;
w_mod   = 0;
wait    = (wait < 0)?  0:  wait;
w_cou   = (1193180l / (long) (TIMER_DIVIDER)) * (long) (wait);
dps8i   = sub8i_dps2_mel;
setvect ( 0x08, sub8i_dps_wait );

disable  ();
	outportb ( 0x43, bin ("00.11.010.0") );
	outportb ( 0x40,  TIMER_DIVIDER       & 0xFF );
	outportb ( 0x40, (TIMER_DIVIDER >> 8) & 0xFF );

	SOUND_OFF ();
	outportb ( 0x43, bin ("10.01.000.0") );
	SOUND_ON  ();
enable ();

t_cou = n_cou = 0;
dps_fp->pbcur = 0;
dps_fp->mode  = 0;

dpsm_fp->mbcur = -1;
dpsm_fp->mode  = mode;

w_mod = 1;
}

/* ......................................................................... */

_dpsp_stop	()		/*  ⠩  室 ﭨ */
{	long	*lp;

if ( dos8i == NULL )	return;

SOUND_OFF ();
disable   ();
	outportb ( 0x43, bin ("00.11.010.0") );
	outportb ( 0x40, 0xFF  );
	outportb ( 0x40, 0xFF  );
	setvect  ( 0x08, dos8i );

	outportb  ( 0x43, bin ("10.11.011.0") );
	outportb  ( 0x42, 0xFF );
	outportb  ( 0x42, 0x00 );
enable    ();
SOUND_OFF ();

lp = MK_FP ( 0x0000, 0x046C );
*lp += ( (dps_tick_count * (long) (TIMER_DIVIDER)) / 65536l );
dps_tick_count = 0l;

}

/* ......................................................................... */
/* ......................................................................... */

static	int	one_octave [] =			/* DPS delay for one octave  */
  {	300,	/*  0  C  */
	282,	/*  1  C# */
	266,	/*  2  R  */
	252,	/*  3  R# */
	238,	/*  4  E  */
	224,	/*  5  F  */
	212,	/*  6  F# */
	200,	/*  7  G  */
	189,	/*  8  G# */
	178,	/*  9  A  */
	168,	/* 10  A# */
	159,	/* 11  H  */
	150,	/* 12  C  */
	  0,	/* 13     */
	  0,	/* 14     */
};

/* ......................................................................... */

melody_to_buf	( unsigned char *cp, struct DPS_FMTM *mel )
{	register	int	i, j;

for ( i=0; (i < mel->mtblen) && *cp; cp++ )
 {
    switch ( upper_c (*cp) )
     {	case 'C':	j =  0;	break;

	case 'R':
	case 'D':	j =  2;	break;

	case 'M':
	case 'E':	j =  4;	break;

	case 'F':	j =  5;	break;

	case 'G':	j =  7;	break;

	case 'L':
	case 'A':	j =  9;	break;

	case 'S':
	case 'B':
	case 'H':	j = 11;	break;

	case 'P':	j = 13;	break;

	default:	j = -1;	break;
     }

    if ( j < 0 )	continue;

    if ( *(cp+1) == '#' )  {	j++;	cp++;	}

    if ( *(cp+1) == EOS )	continue;

    cp++;
    j = one_octave [j];
    switch ( *cp )
     {	case '0':	j *= 4;		break;
	case '1':	j *= 2;		break;
	case '2':			break;
	case '3':	j /= 2;		break;
	default:	j = 0;		break;
     }

    if ( j < 100 )	j = 0;

    *(mel->mbuf + i) = j;
    i++;

 }

mel->mblen =  i;
mel->mbcur = -1;
return;
}

/* ......................................................................... */
/* ......................................................................... */
/* ......................................................................... */
/* ......................................................................... */

void	interrupt	sub8i_dps_wait	()		/* DPS Wait begin    */
{
dps_tick_count ++;
if ( w_mod == 0 )	goto END;

if ( w_cou == 0l )  {	setvect (0x8, dps8i);	w_mod = 0;	}
else	w_cou--;

END:
outportb ( 0x20, 0x20 );
}

/* ......................................................................... */
/* ......................................................................... */

void	interrupt	sub8i_dps1	()		/* DPS play FMT 1    */
{	register	unsigned	int	i;
	register	struct	DPS_FMTS	*dp;
	static	char	hb_cou  = 0;

dps_tick_count ++;
dp = dps_fp;

if ( dp->mode == 0 )	goto END;

outportb ( 0x42, current_volume );	t_cou += 100;

if ( t_cou < dp->cou )	goto END;
t_cou -= dp->cou;

i = dp->pbcur;
if ( ! hb_cou )
  {	current_volume = *(dp->pbuf+i) & 0xF;
	current_volume <<= 2;
	hb_cou = 1;	goto END;	}
hb_cou = 0;

i++;
if ( i >= dp->pblen )
  {	i = 0;
	if ( dp->mode != 2 ) {	if ( dp->mode == 3 )	_dpsp_stop ();
				dp->mode = 0;
				goto END;				}
   }

current_volume = ((*(dp->pbuf+i)) >> 4) & 0xF;
current_volume <<= 2;
dp->pbcur = i;

END:
outportb ( 0x20, 0x20 );
}

/* ......................................................................... */
/* ......................................................................... */

void	interrupt	sub8i_dps2	()		/* DPS play FMT 2    */
{	register	unsigned	int	i;
	register	struct	DPS_FMTS	*dp;

dps_tick_count ++;
dp = dps_fp;

if ( dp->mode == 0 )	goto END;

outportb ( 0x42, current_volume );	t_cou += 100;

if ( t_cou < dp->cou )	goto END;
t_cou -= dp->cou;

i = dp->pbcur + 1;
if ( i >= dp->pblen )
  {	i = 0;
	if ( dp->mode != 2 ) {	if ( dp->mode == 3 )	_dpsp_stop ();
				dp->mode = 0;
				goto END;				}
   }

current_volume = *(dp->pbuf+i) >> 2;
dp->pbcur = i;

END:
outportb ( 0x20, 0x20 );
}

/* ......................................................................... */
/* ......................................................................... */

void	interrupt	sub8i_dps2_mel	()		/* DPS FMT 2 melody  */
{	register	unsigned	int	i;
	register	struct	DPS_FMTS	*dp;

dps_tick_count ++;

if ( dpsm_fp->mode == 0 )	goto END;

dp = dps_fp;

if ( n_cou == 0 )			/* Next note */
 {  if ( dp->mode )	outportb ( 0x42, current_volume );

    i = dpsm_fp->mbcur + 1;
    if ( i >= dpsm_fp->mblen )
     {	i = 0;
	if ( dpsm_fp->mode != 2 )
	  {	if ( dpsm_fp->mode == 3 )	_dpsp_stop ();
		dpsm_fp->mode = 0;		goto END;	}
      }

    dpsm_fp->mbcur = i;

    i = *(dpsm_fp->mbuf + i);
    if ( i >= 100 ) {	dp->cou  = i;	dp->pbcur = 0;
			dp->mode = 1;
			current_volume = *dp->pbuf >> 2;
			t_cou = 0;				}

    n_cou = dpsm_fp->mcou;
    goto END;
 }
else	n_cou --;


if ( dp->mode == 0 )	goto END;

outportb ( 0x42, current_volume );	t_cou += 100;

if ( t_cou < dp->cou )	goto END;
t_cou -= dp->cou;

i = dp->pbcur + 1;
if ( i >= dp->pblen )
  {	i = 0;
	if ( dp->mode != 2 )	dp->mode = 0;
   }

current_volume = *(dp->pbuf+i) >> 2;
dp->pbcur = i;

END:
outportb ( 0x20, 0x20 );
}

/* ......................................................................... */
/* ......................................................................... */





